//revision 1.0.0
/********************************************************************
 title : JavaScript for PhotShop CS,CS2,CS3
 		 PSDJPEGւ̕ϊBJPEG͂̂܂܃Rs[
 author: ASUKANET Co., Ltd. 
 
 made  : 2007.12.03		k.itabashi	rev 1.0
 
 note  : PhotoShop CS , CS2 , CS3 Support
 
********************************************************************/

// Set to 'true' to display debug messages.
var SHOW_DEBUG_MESSAGES = false;
var JPEG_QUALITY=12;
var JPEG_EXTENTION=".jpg";
var JPEG_EXTENTION2=".jpeg";
var TARGET_EXTENTION = ".psd";


var sver     = scriptingVersion.split('.');
var verMajor = sver[0];
var verMinor = sver[1];
var verRev   = sver[2];

var OrgDir = null;

//LZtO
var m_isCanceled = false;

displayDialogs = DialogModes.NO;

main();

/***********************************************************************
* Main
***********************************************************************/
function main(){
	_pathDelimiter = GetPathDelimiter();
	
	if(verMajor >= 8 ){
		wndCSUIProc01();
	}else{
		alert('XNvgsG[!̃XNvgPhotoShop CS ȏłpB');
	}
}

/***********************************************************************
* Script Version 8 over (PhotoShop CS)
* XNvgUI
***********************************************************************/
function wndCSUIProc01(){
	var wnd = null;
	
	//window
	var wndWidth = 480; //EChE̕
	var wndHeight = 240;//EChE̍
	var pnlWidth = wndWidth - 40;//t[̕
	wnd = new Window('dialog','JPG/JPEGϊ');
	wnd.bounds = [200,100,200 + wndWidth,100 + wndHeight];
	
	//controls
	var cY = 10;
	var lbl1        = wnd.add ('statictext'  ,[ 20, cY, 20 + pnlWidth - 40, cY +  25], '쐬ς݂̃f[^JPGɕύX܂B',false);
	// ϊt@C̊i[tH_
	cY += 25;
	var pnl1        = wnd.add ('panel'       ,[ 20, cY, 20 + pnlWidth, cY +  60], 'ϊt@ĈtH_w肵ĉ',false);
	var lblDir      = pnl1.add('statictext'  ,[ 10, 20, 10 + pnlWidth - 70, 20 +  30], '',{multiline:true});
	var btnRef      = pnl1.add('button'      ,[pnlWidth - 60, 20,pnlWidth - 60 +  50, 20 +  25], 'Q');
	
	cY += 100;
	var lbl2        = wnd.add ('statictext'   ,[ 20,cY, 20 + 380,cY +  25], 'sNbNƍ쐬Jn܂B',false);
	cY += 25;
	var lbl3        = wnd.add ('statictext'   ,[ 20,cY, 20 + 380,cY +  25], 'rŒ~ꍇ́AEscL[ĉB',false);

	// OK & Cancel
	//MacOS 10.3.X + CS ̏ꍇ"OK"{^K{̂߃LZɊ蓖āB
	cY += 35;
	var btnCancel= wnd.add    ('button'       ,[ 20,cY, 20 + 100,cY +  25], 'LZ' , { name:'ok'});
	var btnExec  = wnd.add    ('button'       ,[wndWidth - 120 ,cY,wndWidth - 120 + 100,cY +  25], 's');
	
	/************************************/
	/* btnExec onClick Events           */
	/************************************/
	btnExec.onClick = function(){
		var newDir = null;

		m_isCanceled = false;
		btnCancel.text = 'LZ';

		if (confirm(OrgDir.fsName + '̃t@Cϊ܂B')){
			//fBNg쐬
			newDir = new Folder(OrgDir + '/jpg/');
			if (newDir.exists){
				if ( confirm('tH_łɑ݂܂B㏑܂H' + newDir.fsName) == false)
					return false;
			}else{
				newDir = CreatePath(OrgDir,'/jpg/');
			}
			
			ConvertToJpeg(OrgDir,newDir);
			alert('I܂B');
		}
	}
	
	/************************************/
	/* btnCancel onClick Events         */
	/************************************/
	btnCancel.onClick = function()
	{
		m_isCanceled = true;
		wnd.close();
	}

	/************************************/
	/* btnRef onClick Events            */
	/************************************/
	btnRef.onClick = function(){
		var retDir = Folder.selectDialog('ϊt@C̃tH_IĉB',OrgDir);
		if (retDir != null){
			OrgDir = retDir;
			lblDir.text = OrgDir.fsName;
		}
	}

	wnd.show();
}


//convert to jpeg
function ConvertToJpeg(targetDir,otDir)
{
	var index = 0;
	var filecount = 0;
	var Files = targetDir.getFiles();

	while (index < Files.length){
		//PhotoShop7pi΍)
		var modFile = new Folder(Files[index].path);
		var tFile = Files[index].fsName.replace(modFile.fsName,'');
		var TargetPath = targetDir.fsName + tFile;
		if ( Folder(TargetPath) instanceof Folder ){

		}else{
			var TargetFile = new File(TargetPath);
			//psd file
			if (TargetFile.fsName.toLowerCase().match(TARGET_EXTENTION.toLowerCase() + "$")){
				var doc = open(TargetFile);
				var SaveOpt = new JPEGSaveOptions();
				SaveOpt.quality = JPEG_QUALITY;
				doc.saveAs(new File(otDir.fsName + '/' + doc.name.replace(TARGET_EXTENTION, JPEG_EXTENTION)), SaveOpt );
				doc.close();
				filecount++;
			//jpg,jpeg file
			}else if ((TargetFile.fsName.toLowerCase().match(JPEG_EXTENTION.toLowerCase() + "$")) ||
			          (TargetFile.fsName.toLowerCase().match(JPEG_EXTENTION2.toLowerCase() + "$"))){
				TargetFile.copy(otDir.fsName + '/' + TargetFile.name);
				filecount++;
			}
		}
		index++;
	}
}

/********************************************************************
 Creates a folder tree described as a "/" delimited string.
 The folder tree is created under the specified parentFolder object.
********************************************************************/
function CreatePath(parentFolder, path)
{
	var str = new String(path);
	var tokens = str.split('/', 255);
	var fdr = parentFolder;
	
	for (i = 0; i < tokens.length; i++)
	{
		fdr = CreateFolder(fdr, tokens[i]);
	}
	return fdr;
}

/********************************************************************
 Creates a folder with the specified folderName.
 The folder is created under the specified parentFolder object
********************************************************************/
function CreateFolder(parentFolder, folderName)
{
	if (!parentFolder.exists)
	{
		throw('Could not create folder\n' + folderName + '\nwithin non-existant folder\n' + parentFolder.fsName);
	}

	DbgMsg('Creating folder ' + folderName + ' in ' + parentFolder.fsName);	

	var parentName = new String(parentFolder.fsName);
	if (parentName.length > 0)
	{
		parentName += _pathDelimiter;
	}
	
	var folder = new Folder(parentName + folderName);
	if (folder.exists)
	{
		DbgMsg('Folder to create already exists');
		return folder;
	}
	else
	{
		if (folder.create())
		{
			return folder;
		}
		else
		{
			throw('Error creating folder: ' + folder.error);
		}
	}
}


function isWindowsOS()
{
	var Os = Folder.system.toString();
	Os.toLowerCase();
	
	if (Os.indexOf('win') >= 0){
		return true;
	}
	return false;
}

function isMacOS()
{
	return !isWindowsOS();
}

/********************************************************************
Returns the character to use as the file system path delimiter.
This is necessary because certain OS/PS version combinations
require a different delimiter. Stupid, eh?
********************************************************************/
function GetPathDelimiter()

{
	// Get the system folder.
	var path = new String(Folder.system.fsName);

	DbgMsg('Determining path delimiter from the system path: \n' + path);

	// Does the system folder path contain a ':'?
	var index = path.indexOf(':');
	DbgMsg('Index of : = ' + index);

	if (index != -1)
	{
		if (index == 1)
		{
			index = path.indexOf('\\');
			DbgMsg('Index of \\ = ' + index);

			if (index == 2)
			{
				DbgMsg('Delimiter = /');
				return '/';
			}

			DbgMsg('Delimiter = :');
			return ':';
		}

		DbgMsg('Delimiter = :');
		return ':';
	}

	DbgMsg('Delimiter = /');
	return '/';
}

/********************************************************************
 Displays a message box for debugging.  For ease of disabling.
********************************************************************/
function DbgMsg(msg)
{
	if (SHOW_DEBUG_MESSAGES)
	{
		var proceed = confirm(msg + '\n\nContinue?');
		if (!proceed)
		{
			throw 'User requested exit';
		}
	}
}
